
//roughly: 820 lines

//FIXME: split keyboard from video!

#include "gfx.h"

//keyboard
#define REPT_DELAY 250
#define REPT_RATE 33
//
#define KEYMAX 32
int numdown;
int downcodes[KEYMAX];
#define MAXCODES 64
int codelist[MAXCODES];
int codeput,codetake;
int lastcode;
int downtime;
Uint8 stilldown=0;
Uint8 exitflag=0; //keyboard loop exit flag

//SpiroH: mouse emulation coords
Uint16 Mouse_x,Mouse_y;

//video
int vxsize,vysize;
SDL_Surface *thescreen;
int stride;
Uint8 *	videomem;
Uint8 locked=0;
unsigned short *darker,*lighter;

#define MAXBACKBUFFERS 8
Uint8 * backbuffers[MAXBACKBUFFERS]={0};

//SpiroH: font for text drawing
nSDL_Font *nsdl_font; 


//SpiroH: keyboard mapping stuff - will work only for US layouts
int sdl_in_out[]={
SDLK_0,'0',')',
SDLK_1,'1','!',
SDLK_2,'2','@',
SDLK_3,'3','#',
SDLK_4,'4','$',
SDLK_5,'5','%',
SDLK_6,'6','^',
SDLK_7,'7','&',
SDLK_8,'8','*',
SDLK_9,'9','(',
SDLK_a,'a','A',
SDLK_b,'b','B',
SDLK_c,'c','C',
SDLK_d,'d','D',
SDLK_e,'e','E',
SDLK_f,'f','F',
SDLK_g,'g','G',
SDLK_h,'h','H',
SDLK_i,'i','I',
SDLK_j,'j','J',
SDLK_k,'k','K',
SDLK_l,'l','L',
SDLK_m,'m','M',
SDLK_n,'n','N',
SDLK_o,'o','O',
SDLK_p,'p','P',
SDLK_q,'q','Q',
SDLK_r,'r','R',
SDLK_s,'s','S',
SDLK_t,'t','T',
SDLK_u,'u','U',
SDLK_v,'v','V',
SDLK_w,'w','W',
SDLK_x,'x','X',
SDLK_y,'y','Y',
SDLK_z,'z','Z',
SDLK_MINUS,'-','_',
SDLK_EQUALS,'=','+',
SDLK_LEFTBRACKET,'[','{',
SDLK_RIGHTBRACKET,']','}',
SDLK_SEMICOLON,';',':',
SDLK_QUOTE,'\'','"',
SDLK_BACKSLASH,'\\','|',
SDLK_SLASH,'/','?',
SDLK_PERIOD,'.','>',
SDLK_COMMA,',','<',
SDLK_BACKQUOTE,'`','~',
SDLK_BACKSPACE,8,8,
SDLK_TAB,9,9,
SDLK_DELETE,MYDELETE,MYDELETE,
SDLK_RETURN,13,13,
SDLK_F1,MYF1,MYF1,
SDLK_F2,MYF2,MYF2,
SDLK_F3,MYF3,MYF3,
SDLK_F4,MYF4,MYF4,
SDLK_F5,MYF5,MYF5,
SDLK_F6,MYF6,MYF6,
SDLK_F7,MYF7,MYF7,
SDLK_F8,MYF8,MYF8,
SDLK_F9,MYF9,MYF9,
SDLK_F10,MYF10,MYF10,
SDLK_ESCAPE,0x1b,0x1b,
SDLK_LEFT,MYLEFT,MYLEFT,
SDLK_RIGHT,MYRIGHT,MYRIGHT,
SDLK_UP,MYUP,MYUP,
SDLK_DOWN,MYDOWN,MYDOWN,
SDLK_PAGEUP,MYPAGEUP,MYPAGEUP|MYSHIFTED,
SDLK_PAGEDOWN,MYPAGEDOWN,MYPAGEDOWN|MYSHIFTED,
SDLK_SPACE,' ',' ',
SDLK_HOME,MYHOME,MYHOME,
SDLK_END,MYEND,MYEND,
SDLK_LALT,MYALTL,MYALTL,
SDLK_RALT,MYALTR,MYALTR,
SDLK_LCTRL,MYCTRLL,MYCTRLL,
SDLK_RCTRL,MYCTRLR,MYCTRLR,
SDLK_LSHIFT,MYSHIFTL,MYSHIFTL,
SDLK_RSHIFT,MYSHIFTR,MYSHIFTR,
ENDMARK
};//sdl_in_out

int g_nMouseCenterX = SCREEN_WIDTH/2;
int g_nMouseCenterY = SCREEN_HEIGHT/2;
int g_nMouseDown = 0;

//---------------------------------
void map_key(int code,int qual,int *mapped)
{
	int *list=sdl_in_out;

	while(*list!=ENDMARK)
	{
		if(*list==code) break;
		list+=3;
	}
	if(*list==ENDMARK)
	{
		*mapped=mapped[1]=-1;
		return;
	}

	*mapped=(qual&KMOD_SHIFT) ? list[2] : list[1];

	if(qual & KMOD_ALT)  *mapped	|= MYALTED;
	if(qual & KMOD_CTRL) *mapped	&= 0x1f;
	mapped[1]=list[1];
}

//---------------------------------
int next_code(void)
{
int code;
	if(codeput==codetake) return -1;
	code=codelist[codetake];
	codetake=(codetake+1) & (MAXCODES-1);
	return code;
}

//---------------------------------
void addcode(int code)
{
int new;
	new=(codeput+1) & (MAXCODES-1);
	if(new==codetake) return;
	lastcode=code;
	codelist[codeput]=code;
	codeput=new;
}

//---------------------------------
void mark_key(int code,int mod,int status)
{
int i;
int *ip;
int mapped[2];

	map_key(code,mod,mapped);
	code=mapped[1];
	if(code<0) return;
	if(status)
	{
		addcode(*mapped);
		stilldown=1;
		downtime=SDL_GetTicks()+REPT_DELAY;
		ip=downcodes;
		i=numdown;
		while(i)
			if(*ip++==code) break;
			else i--;
		if(!i && numdown<KEYMAX)
			downcodes[numdown++]=code;
	} else
	{
		i=numdown;
		ip=downcodes;
		while(i)
			if(*ip++==code)
			{
				*--ip=downcodes[--numdown];
				break;
			} else i--;
	}

}

//outside switch(event.type)
/*Not good enough!
void check_for_click()
{
	//HACK
	if(isKeyPressed(KEY_NSPIRE_CLICK) ) //emulate mouse click 
	{
		printf("NSPIRE CLICK!\n"); //debug
			
		addcode(MYMOUSE1DOWN);
		addcode(Mouse_x);
		addcode(Mouse_y);
			
	}
}
*/
//---------------------------------
void scan_input(void)
{
SDL_Event event;
int key,mod;
int newtime;
	int emulate_mouse=0; //SpiroH

//	mousedown=0;
	while(SDL_PollEvent(&event))
	{
		
		switch(event.type)
		{
		case SDL_KEYDOWN:
			//printf("KeyDownEvent\n");
			key=event.key.keysym.sym;
		//filter here some key to simulate MouseUp
		
		//mouse Movement-emulation: SpiroH a LOT of changes
			if( (!g_ptad_info && key==SDLK_LEFT) || key==SDLK_4) //emulate mouse movement
			{
				Mouse_x--;
				emulate_mouse=1;
				
			}else
			if( (!g_ptad_info && key==SDLK_RIGHT) || key==SDLK_6 ) //emulate mouse movement
			{
				Mouse_x++;
				emulate_mouse=1;
				
			}else			
			if( (!g_ptad_info && key==SDLK_UP) || key==SDLK_8 ) //emulate mouse movement
			{
				Mouse_y--;
				emulate_mouse=1;

			}else 
			if( (!g_ptad_info && key==SDLK_DOWN) || key==SDLK_2) //emulate mouse movement
			{
				Mouse_y++;
				emulate_mouse=1;
			
			}
			if(key==SDLK_5  ) //emulate mouse click -don't know how to include mouse click? leave if for the moment
			{
				addcode(MYMOUSE1DOWN);
				addcode(Mouse_x);
				addcode(Mouse_y);
			
				break;
			}
		
			
			if(emulate_mouse)
			{
				SDL_WarpMouse(Mouse_x,Mouse_y);
				break;	
			}
			
			//printf("KeyDown - code: %d\n",key); //debug
			mod=event.key.keysym.mod;
			mark_key(key,mod,1);
			break;
		case SDL_KEYUP:
			//printf("KeyUpEvent\n");
			key=event.key.keysym.sym;
		
			if(key==SDLK_5 ) //emulate mouse click -don't know how to include mouse click? leave if for the moment
			{
				addcode(MYMOUSE1UP); //not used??
				addcode(Mouse_x);
				addcode(Mouse_y);
				break;
			}	
		
			mod=event.key.keysym.mod;
			mark_key(key,mod,0);
			stilldown=0;
			break;
//SomeHow we need to replace these!!!!!!!!! well, they should work! myabe we need to see how to define a cursor!
		case SDL_MOUSEBUTTONUP: //never get these!!
			printf("MouseUpEvent\n");
			addcode(MYMOUSE1UP);
			addcode(event.button.x);
			addcode(event.button.y);
			break;
		case SDL_MOUSEBUTTONDOWN:
			printf("MouseDownEvent\n");
			addcode(MYMOUSE1DOWN);
			addcode(event.button.x);
			addcode(event.button.y);
			break;
		case SDL_MOUSEMOTION:
			//printf("MouseMoveEvent\n"); ok
			addcode(MYMOUSEMOVE);
			addcode(event.motion.x);
			addcode(event.motion.y);

			break;
		case SDL_QUIT:
			exitflag = 1;
			break;
		}//switch
		
	}//while
	
	if(stilldown)
	{
		newtime=SDL_GetTicks();
		if(newtime>downtime)
		{
			downtime+=REPT_RATE;
			addcode(lastcode);
		}
	}

	if( g_ptad_info )
	{
		touchpad_scan(&g_tpad_report);
		if( g_tpad_report.proximity > 0 && !g_tpad_report.pressed )
		{
			int nX = g_tpad_report.x * SCREEN_WIDTH / 2328;
			int nY = (1691-g_tpad_report.y) * SCREEN_HEIGHT / 1691;

			if( g_nMouseCenterX < 0 && g_nMouseCenterY < 0 )
			{
				g_nMouseCenterX = nX;
				g_nMouseCenterY = nY;
			}
			int cx = g_nMouseCenterX - nX;
			int cy = g_nMouseCenterY - nY;

			Mouse_x -= cx;
			Mouse_y -= cy;
			//if( Mouse_x < 0 )
			//	Mouse_x = 0;
			if( Mouse_x >= SCREEN_WIDTH )
				Mouse_x = SCREEN_WIDTH-1;
			//if( Mouse_y < 0 )
			//	Mouse_y = 0;
			if( Mouse_y >= SCREEN_HEIGHT )
				Mouse_y = SCREEN_HEIGHT-1;

			if( cx != 0 || cy != 0 )
			{
				g_nMouseCenterX = nX;
				g_nMouseCenterY = nY;

				addcode(MYMOUSEMOVE);
				addcode(Mouse_x);
				addcode(Mouse_y);
				SDL_WarpMouse(Mouse_x,Mouse_y);
			}
		}
		if( g_tpad_report.proximity <= 0 )
		{
			g_nMouseCenterX = -1;
			g_nMouseCenterY = -1;
		}
		if( g_nMouseDown && !g_tpad_report.pressed )
		{
			g_nMouseDown = 0;
		}
		if( !g_nMouseDown && g_tpad_report.pressed && g_tpad_report.arrow == TPAD_ARROW_CLICK/*Center button*/)
		{
			g_nMouseDown = 1;
			addcode(MYMOUSE1DOWN);
			addcode(Mouse_x);
			addcode(Mouse_y);

			addcode(MYMOUSE1UP);
			addcode(Mouse_x);
			addcode(Mouse_y);
		}
	}
}


//============================================
//VIDEO (above^^ is keyboard: FIXME split file into KeyBoard+Video)

//not used- but leave it for the record!
#define GAME_NAME "Lopan - MahJong clone (c) Dave Ashley, 1999"


//---------------------------------
void open_display(int sx,int sy)
{
unsigned long videoflags;
int i;
Uint8 r,g,b;

	static int nBpp=16; 		//Apparently only works with 16bpp - requires mods for nBpp=8, due to direct video memory access!
	int nMaxColors= (1<<nBpp); 	//Max Nbr Colors

	vxsize=sx;
	vysize=sy;
	codeput=codetake=0;

	darker	= malloc(nMaxColors*sizeof(unsigned short));
	lighter	= malloc(nMaxColors*sizeof(unsigned short));

	if(!darker || !lighter) no_mem(5);

	if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
	{
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(1);
	}
	
	//videoflags = SDL_SWSURFACE; //required for direct pixel manipulation!
	videoflags = (SDL_SWSURFACE|SDL_FULLSCREEN|SDL_HWPALETTE); //nSpire //|SDL_HWPALETTE
	
	thescreen = SDL_SetVideoMode(vxsize, vysize, nBpp, videoflags); //why only 16??
	if ( thescreen == NULL )
	{
		fprintf(stderr, "Couldn't set display mode: %s\n", SDL_GetError());
		SDL_Quit();
		exit(5);
	}
	
	//create font
	nsdl_font = nSDL_LoadFont(NSDL_FONT_THIN, 255, 255, 255); //white
	
	// Set window caption
    //SDL_WM_SetCaption(GAME_NAME, GAME_NAME); //not in nSpire

	//set globals
	stride   = thescreen->pitch; //screen width
	videomem = (void *)thescreen->pixels;

	for(i=0; i< nMaxColors ; ++i) 
	{
		SDL_GetRGB(i,thescreen->format,&r,&g,&b);
		darker[i]= SDL_MapRGB(thescreen->format,r*3>>2,g*3>>2,b*3>>2);
		if(r>128 && g>128 && b>128)lighter[i]=SDL_MapRGB(thescreen->format,(r+255)>>1,(g+255)>>1,(b+255)>>1);
		else lighter[i]=i;
	}
	
	//SpiroH for mouse
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL); 
	
	//place mouse at the screen center
	Mouse_x=SCREEN_WIDTH/2;
	Mouse_y=SCREEN_HEIGHT/2;
	Mouse_y-=22; //TILE_H(22) defined in logan.h
	SDL_WarpMouse(Mouse_x,Mouse_y); 
	
	//enable cursor
	SDL_ShowCursor(SDL_ENABLE); 
	
}//open_display

//---------------------------------
void close_display(void)
{
	SDL_Quit();
}
//---------------------------------
void scr_lock(void)
{
	if(!locked && SDL_MUSTLOCK(thescreen))
	{
		if ( SDL_LockSurface(thescreen) < 0 )
		{
			fprintf(stderr, "Couldn't lock display surface: %s\n", SDL_GetError());
		}
	}
	locked=1;
}
//---------------------------------
void scr_unlock(void)
{
	if(locked && SDL_MUSTLOCK(thescreen))
		SDL_UnlockSurface(thescreen);
	locked=0;
}

//---------------------------------
void copy_up(void)
{
	scr_unlock();
	SDL_UpdateRect(thescreen, 0, 0, 0, 0);
}
//---------------------------------
void delay(int ticks)
{
	SDL_Delay(ticks);
}
//---------------------------------

#define IBUFFLEN 1024

int pcx_ileft=0;
Uint8 *pcx_ibuff=0,*pcx_itake;

FILE * pcx_fhand=NULL; //SpiroH to replace pcx_ihand
//---------------------------------
//counter index
Uint8 pcx_ci()
{
	if(!pcx_ileft)
	{		
		pcx_ileft=(int)fread(pcx_ibuff,1,IBUFFLEN,pcx_fhand); //SpiroH: reads a buffer IBUFFLEN from file handle pcx_fhand
		if(!pcx_ileft) return -1;
		pcx_itake=pcx_ibuff;
	}
	pcx_ileft--;
	return *pcx_itake++; //returns actual byte
}
//---------------------------------
void pcx_ci_init(void)
{
	if(!pcx_ibuff) pcx_ibuff=malloc(IBUFFLEN);
	if(!pcx_ibuff) no_mem(1);
	pcx_ileft=0;
}

//---------------------------------
int read_pcx(char *name,surface *gs) //name - file_path_name
{
//.pcx format: http://en.wikipedia.org/wiki/.pcx
int xs,ys;
int i,j,k,n,t;
int totalsize;
int width,height;
int y;
Uint8 *bm,*lp;
int r,g,b;
int numbpp;
Uint8 map48[48];
Uint8 arow[2048];
int perrow;
int pcxbyteswide;

//CLEAN_ME!!
	pcx_ci_init();
	memset(gs,0,sizeof(surface));
	gs->format=FORMAT8; 
	
	pcx_fhand=fopen(name,"r+b"); //SpiroH: must ensure binary read else it defaults to text!
	
	if(pcx_fhand==NULL)
	{
	   //printf("read_pcx: fopen failed!. FileName: %s\n",name ); //SpiroH debug	
		return 1;
	}

	if(pcx_ci()!=10) {fclose(pcx_fhand);return 2;} // 10=zsoft .pcx
	if(pcx_ci()!=5)  {fclose(pcx_fhand);return 3;} // version 3.0
	if(pcx_ci()!=1)  {fclose(pcx_fhand);return 4;} //encoding method

	numbpp=pcx_ci();
//	if(numbpp!=8) {close(pcx_ihand);return 5;} //bpp
	
	//if(numbpp!=8 && numbpp!=1) {close(pcx_ihand);return 5;} //bpp
	if(numbpp!=8 && numbpp!=1) {fclose(pcx_fhand);return 5;} //bpp

	xs	=  pcx_ci();
	xs	|= pcx_ci()<<8;
	ys	=  pcx_ci();
	ys	|= pcx_ci()<<8;
	width =  pcx_ci();
	width |= pcx_ci()<<8;
	height =  pcx_ci();
	height |= pcx_ci()<<8;
	width  = width+1-xs;
	height = height+1-ys;

	for(i=0; i< 4; ++i) pcx_ci();

	for(i=0; i<48; ++i ) map48[i]=pcx_ci();

	pcx_ci();
	n=pcx_ci();
//	if(n!=1) {close(pcx_ihand);return 6;} // # of planes

	if(numbpp==8 && n!=1) {
		fclose(pcx_fhand); //SpiroH
		return 6;} // # of planes

	pcxbyteswide  = pcx_ci();
	pcxbyteswide |= pcx_ci()<<8;
	perrow = pcxbyteswide*n;
	i=pcx_ci();
	i|=pcx_ci()<<8;
//	if(i!=1) {close(ihand);return 7;} // 1=color/bw,2=grey

	for(i=0; i<58; ++i) pcx_ci();

	totalsize=height*width;

	bm=malloc(totalsize);
	if(!bm) {fclose(pcx_fhand);return 8;} // no memory
	memset(bm,0,totalsize);
	gs->pic	  = bm;
	gs->xsize = width;
	gs->ysize = height;

	lp=bm;
	for(y=0;y < height; ++y)
	{
		i=0;
		while(i<perrow)
		{
			j=pcx_ci();
			if(j<0xc0)
			{
				arow[i++]=j;
			} else
			{
				j&=0x3f;
				k=pcx_ci();
				while(j-- && i<perrow)
				{
					arow[i++]=k;
				}
			}
		}
		if(numbpp==8) memcpy(lp,arow,width);
		else
		{
			for(t=0;t<n;++t)
			{
				i=t*pcxbyteswide;
				j=0;
				while(j<width)
				{
					k=arow[i++] | 256;
					while(!(k&0x10000) && j < width)
					{
						if(k&0x80) lp[j]|=1<<t;
						k<<=1;
						++j;
					}
				}
			}
		}
		lp+=width;
	}

	if(numbpp==8)
	{	
		//SpiroH: http://en.wikipedia.org/wiki/.pcx
		//If a PCX file has a 256 color palette, it is found 768 (0x300) bytes from the end of the file. 
		//In this case the value in the byte preceding the palette should be 12 (0x0C). 
		//The palette is stored as a sequence of RGB triples; its usable length is defined by the number of colors in the image. 
		//Colors values in a PCX palette always use 8 bits, regardless of the bit depth of the image.
		
		fseek(pcx_fhand,-0x300,SEEK_END); //SpiroH
		pcx_ileft=0;
		for(i=0;i < 256; ++i ) //read 256 color indexes from file!
		{
			r = pcx_ci();
			g = pcx_ci();
			b = pcx_ci();
			gs->rgb[i]=SDL_MapRGB(thescreen->format,r,g,b);
		}
	} 
	else
	{
		for(i=0,j=0;i < 16; ++i)
		{
			r=map48[j++];
			g=map48[j++];
			b=map48[j++];

			gs->rgb[i]=SDL_MapRGB(thescreen->format,r,g,b);
		}
	}

	fclose(pcx_fhand);
	return 0;
}//read_pcx


//---------------------------------
void gs_to_back(int destx,int desty,surface *gs,int sourcex,int sourcey,int sizex,int sizey)
{
unsigned short *ps;
Uint8 *p;
int i;

	if(destx>=vxsize || desty>=vysize) return;

		
	if(destx<0)
	{
		sourcex-=destx;
		sizex+=destx;
		destx=0;
	}
	if(desty<0)
	{
		sourcey-=desty;
		sizey+=desty;
		desty=0;
	}

	if(destx + sizex > vxsize) sizex = vxsize - destx;
	if(desty + sizey > vysize) sizey = vysize - desty;

	//copy tile from surface(gs) to screen surface (ps)
	//by direct thescreen->pixels manipulation via SDL scrlock + scrunlock
	p=gs->pic + sourcex + sourcey*gs->xsize;
	
	ps=(void *)(videomem + stride*desty + (destx << 1) ); //screen

	while(sizey--)
	{
		i=sizex;	

		while(i--) *ps++=gs->rgb[*p++];		
		ps = (void *)((char *)ps + stride-sizex-sizex);
		p+=gs->xsize-sizex;

	}
	
}//gs_to_back

//---------------------------------
void erase_rect(int x,int y,int sizex,int sizey)
{
Uint8 *p;
	if(y<0)
	{
		sizey+=y;
		y=0;
	}
	if(x<0)
	{
		sizex+=x;
		x=0;
	}
	if(x+sizex>vxsize)
		sizex=vxsize-x;
	if(y+sizey>vysize)
		sizey=vysize-y;
	p=videomem+stride*y+(x<<1);
	sizex<<=1;
	while(sizey-->0)
	{
		memset(p,0,sizex);
		p+=stride;
	}

}//erase_rect

//---------------------------------
void transform_rect(int x,int y,int sizex,int sizey,unsigned short *trans)
{
unsigned short *p;
int i;
	if(y<0)
	{
		sizey+=y;
		y=0;
	}
	if(x<0)
	{
		sizex+=x;
		x=0;
	}
	if(x+sizex>vxsize)
		sizex=vxsize-x;
	if(y+sizey>vysize)
		sizey=vysize-y;
	p=(void *)(videomem+stride*y+(x<<1));
	while(sizey-->0)
	{
		i=sizex;
		while(i-->0)
			p[i]=trans[p[i]];
		p = (void *)((char *)p + stride);
	}
}//transform_rect

//---------------------------------
void darken_rect(int x,int y,int sizex,int sizey)
{
	transform_rect(x,y,sizex,sizey,darker);
}

//---------------------------------
void lighten_rect(int x,int y,int sizex,int sizey)
{
	transform_rect(x,y,sizex,sizey,lighter);
}

//---------------------------------
void solid_rect(int x,int y,int sizex,int sizey,Uint8 r,Uint8 g,Uint8 b)
{
unsigned short *p;
int i;
int c;
	c=SDL_MapRGB(thescreen->format,r,g,b);
	if(y<0)
	{
		sizey+=y;
		y=0;
	}
	if(x<0)
	{
		sizex+=x;
		x=0;
	}
	if(x+sizex>vxsize)
		sizex=vxsize-x;
	if(y+sizey>vysize)
		sizey=vysize-y;
	p=(void *)(videomem+stride*y+(x<<1));
	while(sizey-->0)
	{
		i=sizex;
		while(i-->0)
			p[i]=c;
		p = (void *)((char *)p + stride);
	}
}

//---------------------------------
void copy_to_back(unsigned int n)
{
int i;
Uint8 *p1,*p2;

	if(n>=MAXBACKBUFFERS) return;
	if(!backbuffers[n])
	{
		backbuffers[n]=malloc(vxsize*vysize*sizeof(unsigned short));
		if(!backbuffers[n]) no_mem(25);
	}
	p1=backbuffers[n];
	p2=videomem;
	i=vysize;
	while(i--)
	{
		memcpy(p1,p2,vxsize<<1);
		p1+=vxsize<<1;
		p2+=stride;
	}
}

//---------------------------------
void copy_from_back(unsigned int n)
{
int i;
Uint8 *p1,*p2;
	if(n>=MAXBACKBUFFERS || !backbuffers[n]) return;
	p1=backbuffers[n];
	p2=videomem;
	i=vysize;
	while(i--)
	{
		memcpy(p2,p1,vxsize<<1);
		p1+=vxsize<<1;
		p2+=stride;
	}
}

//---------------------------------
void free_gs(surface *gs)
{
	if(gs->pic)
	{
		free(gs->pic);
		gs->pic=0;
	}
}

//---------------------------------
int map_rgb(int r,int g,int b)
{
	return SDL_MapRGB(thescreen->format,r,g,b);
}

//---------------------------------
//SpiroH port
void draw_printf_xy(int x,int y, char* fmt, char* msg)
{
	nSDL_DrawString(thescreen, nsdl_font, x, y , fmt, msg ); //OK
}
