
#include <os.h>
#include <SDL/SDL.h>

extern int vxsize,vysize;

typedef struct surface
{
	Uint8 format;
	unsigned int  rgb[256];
	Uint8 *pic;
	int xsize;
	int ysize;
} surface;

//enum
#define FORMAT8		0
#define FORMAT16	1
#define FORMAT32	2

//#define MYF1		0x180
//#define MYF2		0x181
#define MYF1		SDLK_7  //SpiroH
#define MYF2		SDLK_9  //SpiroH
//
#define MYF3		0x182
#define MYF4		0x183
#define MYF5		0x184
#define MYF6		0x185
#define MYF7		0x186
#define MYF8		0x187
#define MYF9		0x188
#define MYF10		0x189
//#define MYLEFT		0x190
//#define MYRIGHT		0x191
#define MYLEFT		SDLK_1  //Undo
#define MYRIGHT		SDLK_3  //Redo

#define MYUP		0x192
#define MYDOWN		0x193
#define MYPAGEUP	0x194
#define MYPAGEDOWN	0x195
#define MYHOME		0x196
#define MYEND		0x197
#define MYALTL		0x198
#define MYALTR		0x199
#define MYCTRLL		0x19a
#define MYCTRLR		0x19b
#define MYSHIFTL	0x19c
#define MYSHIFTR	0x19d

// mouse events followed by int x,int y 
#define MYMOUSE 0x400
#define MYMOUSE1DOWN (MYMOUSE)
#define MYMOUSE2DOWN (MYMOUSE|1)
#define MYMOUSE3DOWN (MYMOUSE|2)
#define MYMOUSE1UP	(MYMOUSE|3)
#define MYMOUSE2UP	(MYMOUSE|4)
#define MYMOUSE3UP	(MYMOUSE|5)
#define MYMOUSEMOVE (MYMOUSE|6)

#define ENDMARK 0xffffff

#define MYDELETE 0x7f
#define MYSHIFTED 0x40
#define MYALTED 0x200
#define MYMOUSE 0x400

extern Uint8 *videomem;
extern int stride;
extern Uint8 exitflag;

touchpad_report_t g_tpad_report;
extern touchpad_info_t* g_ptad_info;

//read pcx bitmap file
int		read_pcx(char *name,surface *gs);

void	delay(int);
//
//keyboard
void	map_key(int code,int qual,int *mapped);
void	mark_key(int code,int mod,int status);
int		next_code(void);
void	scan_input(void);

//screen
void	open_display(int sx,int sy);
void	close_display(void);
void	free_gs(surface *gs);
//direct pixel
void	scr_unlock(void);
void	scr_lock(void);
//surface blitting
void	gs_to_back(int destx,int desty,surface *gs,int sourcex,int sourcey,int sizex,int sizey);
void	copy_up(void);
void	copy_to_back(unsigned int n);
void	copy_from_back(unsigned int n);
//rect drawing primitives
void	erase_rect(int x,int y,int sizex,int sizey);
void	solid_rect(int x,int y,int sizex,int sizey,Uint8 r,Uint8 g,Uint8 b);
void	darken_rect(int x,int y,int sizex,int sizey);
void	lighten_rect(int x,int y,int sizex,int sizey);
void	transform_rect(int x,int y,int sizex,int sizey,unsigned short *trans);


int		map_rgb(int r,int g,int b);

void    draw_printf_xy(int x,int y, char* fmt, char* msg); //SpiroH

// lopan.c
void no_mem(int code);

//
//void check_for_click(); //spiroH


