

#include <os.h>
#include <SDL/SDL.h>

//===========================
#define DATA_DIR "Data" 	//relative directory with Tiles+Backgrounds

#define BORDER 0x303030

#define NBR_TILES (144)

#define TILE_W (19)			//SpiroH - this assumes tile0/1: (19+2)*9 = 189
#define TILE_H (22)			//							     (22+2)*5 = 120
#define TILES_ROW (9)   	//Tiles Per Row

//these are handy to position the complete board of tiles where we need!
#define SURFACE_OFF_X (TILE_W/2+1)  //SpiroH
#define SURFACE_OFF_Y (4)			//SpiroH - even with this value set to zero, we have a y offset because tiles are draw starting from the center, i gather!

//already defined in ndless
//#define SCREEN_WIDTH  (320)
//#define SCREEN_HEIGHT (240)
//===========================


#include "gfx.h"
//#include "font.h" //no font needed SpiroH

char*    g_argv0=NULL; 		//hack for relative paths!

surface tiles_gs;
int		bg_set_number;
int		tile_set_number;
//char*	msg; 				//replaced by b_click_on_a_tile for 'ndless'
int		b_click_on_a_tile;

//Not all global variables need a special treatment, only those containing string constants and reference to other global elements. nl_relocdata() is documented on Hackspire.
//well, this doesn't work properly in 'ndless' why?
//char*	click_on_a_tile			=	"Click on a tile";
//char*	click_on_another_tile	=	"Click on another tile"; 


//SiproH xged to enum
enum _TileType{
	TILELOCKED	=0x01,
	TILEGONE	=0x02,
	TILERIGHT1	=0x04,
	TILERIGHT2	=0x08,
	TILETOP		=0x10,
	TILELEFT	=0x20,
	TILEBOTTOM	=0x40,
	TILEBRIGHT	=0x80,
	TILESELECT	=0x100
};

struct tile
{
	Uint8 x,y;
	int sx,sy;
	unsigned h,t;
	unsigned int flags;
} tiles[NBR_TILES];
int tilecount;

int solution[NBR_TILES];

//u8 *shadow_plane; //SpiroH removed!
int removed,backed;

// depth,x,y 
int layout[]=
{
1,2,0,
1,4,0,
1,6,0,
1,8,0,
1,10,0,
1,12,0,
1,14,0,
1,16,0,
1,18,0,
1,20,0,
1,22,0,
1,24,0,
1,6,2,
2,8,2,
2,10,2,
2,12,2,
2,14,2,
2,16,2,
2,18,2,
1,20,2,
1,4,4,
1,6,4,
2,8,4,
3,10,4,
3,12,4,
3,14,4,
3,16,4,
2,18,4,
1,20,4,
1,22,4,
1,2,6,
1,4,6,
1,6,6,
2,8,6,
3,10,6,
4,12,6,
4,14,6,
3,16,6,
2,18,6,
1,20,6,
1,22,6,
1,24,6,
1,0,7,
1,26,7,
1,28,7,
-5,13,7,
1,2,8,
1,4,8,
1,6,8,
2,8,8,
3,10,8,
4,12,8,
4,14,8,
3,16,8,
2,18,8,
1,20,8,
1,22,8,
1,24,8,
1,4,10,
1,6,10,
2,8,10,
3,10,10,
3,12,10,
3,14,10,
3,16,10,
2,18,10,
1,20,10,
1,22,10,
1,6,12,
2,8,12,
2,10,12,
2,12,12,
2,14,12,
2,16,12,
2,18,12,
1,20,12,
1,2,14,
1,4,14,
1,6,14,
1,8,14,
1,10,14,
1,12,14,
1,14,14,
1,16,14,
1,18,14,
1,20,14,
1,22,14,
1,24,14,
0,
};

