
//02Oct12: SpiroH

//roughly: 540 lines
#include "lopan.h"

touchpad_info_t* g_ptad_info;

//SpiroH: hack for relative paths
//--------------------------
char* GetDataDir()
{
	static char word_dir[256]; 
	char* p = strrchr(g_argv0,'/'); //assume unix type!
	
	memset(word_dir,0,sizeof(word_dir));
	strncpy(word_dir,g_argv0,p-g_argv0+1);
	strcat(word_dir,DATA_DIR);

	return word_dir;
}
//--------------------------
void randomize(void)
{
	//this call causes a reference to 'gettimeoftheday'
	//srand((int)time(NULL)); //nSpire-WATCH OUT
	srand(SDL_GetTicks()); //nSpire
}
//--------------------------
void no_mem(int code)
{
	printf("No memory: %d\n",code);
	exit(1);
}
//--------------------------
void set_free_bits(void)
{
	int k,tc,x,y;
	
	Uint8 bitmap[40][40]; //SpiroH: what is this magic 40x40 ? maybe tiles-layout map
	
	struct tile *at;

	memset(bitmap,0,sizeof(bitmap));
	
	at=tiles;
	tc=0;
	while(tc < NBR_TILES)
	{
		at=tiles+tc++;

		at->flags &= ~(TILELOCKED|TILERIGHT1|TILERIGHT2|TILETOP|TILEBOTTOM|TILELEFT);
		if(at->flags&TILEGONE) continue;
		
		k = 1<<at->h;
		x = at->x+2;
		y = at->y+2;

		bitmap[x][y]	|=k;
		bitmap[x+1][y]	|=k;
		bitmap[x][y+1]	|=k;
		bitmap[x+1][y+1]|=k;
	}

	tc=0;
	while(tc < NBR_TILES)
	{
		at=tiles+tc++;
		k =1<<at->h;
		x =at->x+2;
		y =at->y+2;
		
		if( ((bitmap[x-1][y]|bitmap[x-1][y+1]) & (bitmap[x+2][y]|bitmap[x+2][y+1]) & k) ||
			((bitmap[x][y]|bitmap[x+1][y]|bitmap[x][y+1]|bitmap[x+1][y+1]) & (k<<1)))		
			at->flags|=TILELOCKED;
		
		if( !((bitmap[x][y-1]|bitmap[x+1][y-1])&k) )
			at->flags|=TILETOP;
		if( !(bitmap[x+2][y]&k) )
			at->flags|=TILERIGHT1;
		if( !(bitmap[x+2][y+1]&k) )
			at->flags|=TILERIGHT2;
		if( !((bitmap[x-1][y]|bitmap[x-1][y+1])&k) )
			at->flags|=TILELEFT;
		if( !((bitmap[x][y+2]|bitmap[x+1][y+2])&k) )
			at->flags|=TILEBOTTOM;
	}
	
}//set_free_bits

//--------------------------
int intcomp(const void *a,const void *b)
{
	return *(int *)a - *(int *)b;
}
//--------------------------
int match(int a,int b)
{
	if(a < 34 && b < 34) return a==b;

	if(a>=36 && a<=39 && b>=36 && b<=39) return 1;

	return a>=40 && a<=43 && b>=40 && b<=43;
}

//--------------------------
void scan_layout(int *p)
{
int i,j,k,h,a,b;
int shuffle[NBR_TILES];
int pairs[NBR_TILES];

	for(i=0; i < NBR_TILES; ++i)
	{
		if( i < 34*4 ) j = i>>2;
		else j=i-136+36;
		
		shuffle[i]=j | (rand()&0xffff00); //nSpire-WATCH OUT
	}

	qsort(shuffle,NBR_TILES,sizeof(int),intcomp);

	for(i=0; i < NBR_TILES; ++i) shuffle[i]&=255;

	k=0;
	for(i=0; i < NBR_TILES-1 ; ++i)
	{
		a=shuffle[i];
		if(a<0) continue;
		
		for(j=i+1; j<NBR_TILES; ++j)
		{
			b=shuffle[j];
			if(b<0) continue;
			if(match(a,b))
			{
				pairs[k++]=a;
				pairs[k++]=b;
				shuffle[i]=-1;
				shuffle[j]=-1;
				break;
			}
		}
	}

	p=layout;
	tilecount=0;
	while((h=*p++))
	{
		i=*p++;
		j=*p++;
		if(h<0)
		{
			tiles[tilecount].x=i;
			tiles[tilecount].y=j;
			tiles[tilecount].h=-1-h;

			tiles[tilecount].t=pairs[tilecount];
			tiles[tilecount].flags=0;
			++tilecount;
		} else
			for(k=0;k<h;++k)
			{
				tiles[tilecount].x=i;
				tiles[tilecount].y=j;
				tiles[tilecount].h=k;
				tiles[tilecount].t=pairs[tilecount];
				tiles[tilecount].flags=0;
				++tilecount;
			}
	}
	
retry:
	for(i=0; i <NBR_TILES; ++i)
		tiles[i].flags=0;
	k=0;
	while(k < NBR_TILES)
	{
		set_free_bits();
		j=0;
		for(i=0;i<NBR_TILES;++i)
		{
			if(tiles[i].flags&(TILEGONE|TILELOCKED)) continue;
//printf("%d:(%d,%d,%d)\n",j,tiles[i].x,tiles[i].y,tiles[i].h);
			shuffle[j++]=i | (rand()&0xffff00); //rand
		}
		
		if(j<2) goto retry;
		
		qsort(shuffle,j,sizeof(int),intcomp);
//printf("%d:%d free:taking %d and %d\n",k,j,shuffle[0]&255,shuffle[1]&255);
		i=shuffle[0]&255;
		solution[k]=i;
		tiles[i].flags|=TILEGONE;
		tiles[i].t=pairs[k++];
		i=shuffle[1]&255;
		solution[k]=i;
		tiles[i].flags|=TILEGONE;
		tiles[i].t=pairs[k++];
	}
	for(i=0;i < NBR_TILES;++i)
		tiles[i].flags&=~TILEGONE;
	
	removed=0;
	backed=0; 	//change this to 72 to have solution visible on startup...
}//scan_layout



//--------------------------
void shadow_solid_rect(int x,int y,int xsize,int ysize,int rgb)
{
	solid_rect(x,y,xsize,ysize,rgb>>16,rgb>>8,rgb);
	//shadow_rect(x,y,xsize,ysize,0);
}


//----------------------------------------
void do_it(void)
{
	//SPiroH: moved in here for ndless
	static char*	click_on_a_tile			=	"Click on a tile";
	static char*	click_on_another_tile	=	"Click on another tile"; 

	int i,j,k,h;
	int x,y,flags;

	copy_from_back(0);

	//draw_printf_xy(vxsize-140,vysize-80,msg); //drawstring
	draw_printf_xy(vxsize>>5,vysize-20, "%s", b_click_on_a_tile?click_on_a_tile:click_on_another_tile);
	
	set_free_bits();
	//clear_shadow_plane();
	
	//set tiles sizes
	for(i=0; i< NBR_TILES; ++i)
	{
		j=tiles[i].h<<2;
		tiles[i].sx=tiles[i].x*(TILE_W/2+1)+2+j;  //SpiroH
		tiles[i].sy=tiles[i].y*(TILE_H/2+1)+10-j; //SpiroH
	}


	for(h=0; h < 7; ++h)
	{
		
		//SpiroH: skip global shadows around the pieces (too much clutter for such a small screen size!) 
		//code removed...

		for(i=0;i < tilecount; ++i)
		{
			if(tiles[i].h!=h) continue;
			flags=tiles[i].flags;
			if(flags&TILEGONE) continue;

			x=tiles[i].sx;
			y=tiles[i].sy;
			k=tiles[i].t;
			
			x+=SURFACE_OFF_X;
			y+=SURFACE_OFF_Y;

			//THIS SHADOW STUFF IS AWKWARD.....TO IMPROVE IN FINAL...VERSION if possible..
			if(flags&TILELEFT)
			{
				//shadow_solid_rect(x-4,y+2,2,TILE_H+2,0xe7e3c7);
				//shadow_solid_rect(x-6,y+4,2,TILE_H+2,0xf7f3f7);

				shadow_solid_rect(x-3,y+3,1,TILE_H,0xe7e3c7);
				shadow_solid_rect(x-4,y+4,1,TILE_H,0xf7f3f7);
			}

			//shadow_solid_rect(x+TILE_W-2,y+2,2,TILE_H+2,BORDER);
			//shadow_solid_rect(x-2,y,TILE_W+2,2,BORDER);

			shadow_solid_rect(x+TILE_W-2,y+1,1,TILE_H,BORDER); //right
			shadow_solid_rect(x-1,y+1,TILE_W+1,1,BORDER); //top

			if(flags&TILEBOTTOM)
			{
			//	shadow_solid_rect(x-2,y+TILE_H+2,TILE_W,2,0xe7e3c7);
			//	shadow_solid_rect(x-4,y+TILE_H+4,TILE_W,2,0xf7f3f7);
				shadow_solid_rect(x-3,y+TILE_H+2,TILE_W,1,0xe7e3c7);

			} else
			{
				//shadow_solid_rect(x-2,y+TILE_H+2,TILE_W+2,2,BORDER);
				shadow_solid_rect(x-3,y+TILE_H+3,TILE_W+2,1,BORDER);
			}


			//void gs_to_back(int destx,int desty,surface *gs,int sourcex,int sourcey,int sizex,int sizey)
			gs_to_back(x-2,y+2,&tiles_gs,(TILE_W+2)*(k%TILES_ROW),(TILE_H+2)*(k/TILES_ROW),TILE_W,TILE_H); //game_surface(tiles_gs) to screen_surface
			
			if(flags&(TILEBRIGHT|TILESELECT))
				if(!(flags&TILEBRIGHT) || !(flags&TILESELECT))
					lighten_rect(x-2,y+2,TILE_W,TILE_H);

			//shadow_rect(x-2,y+2,TILE_W,TILE_H,0); //over all shadow - removed


		}//for tile
		
	}

	//apply_shadow_plane(shadow_plane); //SpiroH - removed
}//do_it

//--------------------------
void new_bg_set(void)
{
	int i,j,sx,sy;
	//char temp[64];
	char temp[256];
	surface bgset;


	for(;;)
	{
		++bg_set_number;
//		sprintf(temp,DATA_DIR "/bg%d.pcx",bg_set_number);
		sprintf(temp,"%s/bg%d.pcx.tns",GetDataDir(),bg_set_number); //new_bg_set - nSpire add .tns
		i=read_pcx(temp,&bgset);
		if(i)
		{
			if(!bg_set_number) return;
			bg_set_number=-1; //resets on first bad found?
		} else
		{
			j=0;
			sy=bgset.ysize;
			while(j<vysize)
			{
				i=0;
				if(j+sy>vysize) sy=vysize-j;
				sx=bgset.xsize;
				while(i<vxsize)
				{
					if(i+sx>vxsize) sx=vxsize-i;
					gs_to_back(i,j,&bgset,0,0,sx,sy);
					i+=sx;
				}
				j+=sy;
			}
			copy_to_back(0);
			free_gs(&bgset);
			break;
		}
	}
	
}
//--------------------------
int new_tile_set(void)
{
	printf("DATA_DIR: %s\n", GetDataDir());
	int err;
	char temp[256];

	free_gs(&tiles_gs);
	for(;;)
	{
		++tile_set_number;
//		sprintf(temp,DATA_DIR "/tiles%d.pcx",tile_set_number);
		sprintf(temp,"%s/tiles%d.pcx.tns",GetDataDir(),tile_set_number); //new_tile_set - nSpire add .tns
		err=read_pcx(temp,&tiles_gs);
		if(!err) return 0;
		else if(!tile_set_number) return err;
		else tile_set_number=-1;
	}
}

//--------------------------
//MOUSE handler
int process_mouse(int code,int mx,int my) //SpiroH: here
{
int i,j,x,y;
	
	if(code!=MYMOUSE1DOWN) return 0; //rejects all other events
	
	j=-1;
	for(i=0;i<NBR_TILES;++i)
	{
		x=tiles[i].sx;
		y=tiles[i].sy;

		x+=SURFACE_OFF_X; //SpiroH
		y+=SURFACE_OFF_Y;

		//if(mx>=x && mx<x+40 && my>=y && my<y+46)
		if(mx>=x && mx<x+TILE_W && my>=y && my<y+TILE_H) //SpiroH
		{
			if(tiles[i].flags&(TILELOCKED|TILEGONE)) continue;
			if(j<0 || tiles[i].h>tiles[j].h)
				j=i;
		}
	}

	if(j<0 || (tiles[j].flags&TILELOCKED)) return 0;
	tiles[j].flags^=TILESELECT;
	if(tiles[j].flags&TILESELECT)
	{
		for(i=0;i<NBR_TILES;++i)
			if(i!=j && (tiles[i].flags&TILESELECT))
				break;
		if(i<NBR_TILES)
		{
			if(match(tiles[i].t,tiles[j].t))
			{
				backed=0;
				solution[removed++]=i;
				solution[removed++]=j;
				tiles[i].flags|=TILEGONE;
				tiles[j].flags|=TILEGONE;
				tiles[i].flags&=~TILESELECT;
				
				b_click_on_a_tile=1; //SpiroH - hack
			}
			tiles[j].flags&=~TILESELECT;
		} else b_click_on_a_tile=0; //SpiroH - hack
		
	} else b_click_on_a_tile=1; //SpiroH - hack
	
		
	return 1;
}//process_mouse


//------------------------------------
int main(int argc, char **argv)
{
	int i,code,backup;
	Uint8 redraw;
	
	g_argv0 = argv[0]; //hack to convert relative paths to absolute paths

	bg_set_number=tile_set_number=-1;
	b_click_on_a_tile=1; 				//SpiroH - hack
	
	randomize();
	open_display(SCREEN_WIDTH,SCREEN_HEIGHT);
	
//	atexit(close_display); //always crashes in 'ndless'!

	tiles_gs.pic=0;
	
	if((i=new_tile_set()))
	{
		printf("Failed to load a tile set, code %d\n",i);
		exit(2);
	}
	

	solid_rect(0,0,vxsize,vysize,0x3c,0x54,0x0c); //green back
	
	copy_to_back(0);
//	new_bg_set(); 

	scan_layout(layout);
	redraw=1;
	backup=0;
	
	g_ptad_info = touchpad_getinfo();
	
	while(!exitflag)
	{
		delay(10);

		while(scan_input(),(code=next_code())>=0)
		{
			//check_for_click();
		
			if(code&MYMOUSE)
			{
				int x,y;
				x=next_code();
				y=next_code();
				redraw|=process_mouse(code,x,y); //main: line 373
			} 
			else if(code==SDLK_RETURN) //return
			{
				scan_layout(layout);				
				b_click_on_a_tile=1; //SpiroH -hack
				
				i=0;
				redraw=1;
			} 
			else if(code==MYLEFT) backup=1;
			else if(code==MYRIGHT) backup=-1;
			
			else if(code==MYF1)
			{
				new_tile_set();
				redraw=1;
			}
			else if(code==MYF2)
			{
				new_bg_set();
				redraw=1;
			} else if(code==SDLK_ESCAPE) exitflag=1;
		}

		if(redraw) 
		{
			SDL_ShowCursor(0); 	//SpiroH - Great this works!
			do_it(); 			//main
			copy_up(); 			//SDL update screen
			SDL_ShowCursor(1); //SpiroH 
			
			redraw=0;
		}

		if(backup)
		{
			if(backup>0)
			{
				if(removed)
				{
					tiles[solution[--removed]].flags&=~TILEGONE;
					tiles[solution[--removed]].flags&=~TILEGONE;
					++backed;
					redraw=1;
				}
			} else
			{
				if(backed)
				{
					--backed;
					tiles[solution[removed++]].flags|=TILEGONE;
					tiles[solution[removed++]].flags|=TILEGONE;
					redraw=1;
				}
			}
			backup=0;
		}

	}//while(!exitflag)

	return 0;

}//main
